'''
Script to set the URL for a HTTP request and trigger the POST Request
Ex:
/usr/bin/python3 /var/www/nebuleair_pro_4g/SARA/SSL/full_test_HTTPS.py ttyAMA2 api-prod.uspot.probesys.net

To do: need to add profile id as parameter

First profile id:
    AT+UHTTP=0,1,"data.nebuleair.fr"
Second profile id:
    AT+UHTTP=1,1,"api-prod.uspot.probesys.net"
Third profile id:
    AT+UHTTP=2,1,"aircarto.fr"

'''

import serial
import time
import sys
import json

parameter = sys.argv[1:]  # Exclude the script name
#print("Parameters received:")
port='/dev/'+parameter[0] # ex: ttyAMA2
url = parameter[1]  # ex: data.mobileair.fr

profile_id = 3

baudrate = 115200
send_uSpot = False

def read_complete_response(serial_connection, timeout=2, end_of_response_timeout=2):
    response = bytearray()
    serial_connection.timeout = timeout
    end_time = time.time() + end_of_response_timeout

    while True:
        if serial_connection.in_waiting > 0:
            data = serial_connection.read(serial_connection.in_waiting)
            response.extend(data)
            end_time = time.time() + end_of_response_timeout  # Reset timeout on new data
        elif time.time() > end_time:
            break
        time.sleep(0.1)  # Short sleep to prevent busy waiting

    return response.decode('utf-8', errors='replace')

ser_sara = serial.Serial(
    port=port,  #USB0 or ttyS0
    baudrate=baudrate, #115200 ou 9600
    parity=serial.PARITY_NONE, #PARITY_NONE, PARITY_EVEN or PARITY_ODD
    stopbits=serial.STOPBITS_ONE,
    bytesize=serial.EIGHTBITS,
    timeout = 2
)


try:
    #step 1: import the certificate
    print("****")
    print("Add certificate")
    with open("/var/www/nebuleair_pro_4g/SARA/SSL/isrgrootx1.der", "rb") as cert_file:
        certificate = cert_file.read()

    size_of_string = len(certificate)

    command = f'AT+USECMNG=0,0,"myCertificate2",{size_of_string}\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_1 = read_complete_response(ser_sara)
    print("Write certificate metadata")
    print(response_SARA_1)

    time.sleep(1)

    ser_sara.write(certificate)
    response_SARA_2 = read_complete_response(ser_sara)
    print("Write certificate data")
    print(response_SARA_2)

    time.sleep(1)

   
    #step 4: set url (op_code = 1)
    print("****")
    print("SET URL")
    command = f'AT+UHTTP={profile_id},1,"{url}"\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_5 = read_complete_response(ser_sara)
    print(response_SARA_5)
    time.sleep(1)

    #step 4: set PORT (op_code = 5)
    print("****")
    print("SET PORT")
    command = f'AT+UHTTP={profile_id},5,443\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_55 = read_complete_response(ser_sara)
    print(response_SARA_55)
    time.sleep(1)

    #step 4: set url to SSL (op_code = 6) (http_secure = 1 for HTTPS)(USECMNG_PROFILE = 2)
    print("****")
    print("SET SSL")
    command = f'AT+UHTTP={profile_id},6,1\r'
    ser_sara.write(command.encode('utf-8'))
    response_SARA_5 = read_complete_response(ser_sara)
    print(response_SARA_5)
    time.sleep(1)

    #step 4: trigger the request (http_command=1 for GET)
    print("****")
    print("Trigger POST REQUEST")
    command = f'AT+UHTTPC={profile_id},1,"/tests/test.php","https.resp"\r'
    #command = f'AT+UHTTPC={profile_id},1,"/nebuleair?token=2AFF6dQk68daFZ","https.resp"\r'

    ser_sara.write(command.encode('utf-8'))
    
    # Wait for the +UUHTTPCR response
    print("Waiting for +UUHTTPCR response...")
    
    response_received = False
    while not response_received:
        response = read_complete_response(ser_sara, timeout=5)
        print(response)
        if "+UUHTTPCR" in response:
            response_received = True

    #READ REPLY
    print("****")
    print("Read reply from server")
    ser_sara.write(b'AT+URDFILE="https.resp"\r')              
    response_SARA_7 = read_complete_response(ser_sara)        
    print("Reply from server:")
    print(response_SARA_7)


except serial.SerialException as e:
    print(f"Error: {e}")

finally:
    if ser_sara.is_open:
        ser_sara.close()
        print("****")
        #print("Serial closed")

